---
title: list-user-events
product: vercel
url: /docs/rest-api/user/list-user-events
type: reference
prerequisites:
  []
related:
  - /docs/rest-api
summary: Learn about list-user-events on Vercel.
install_vercel_plugin: npx plugins add vercel/vercel-plugin
---

# List User Events

```http
GET /v3/events
```

Retrieves a list of "events" generated by the User on Vercel. Events are generated when the User performs a particular action, such as logging in, creating a deployment, and joining a Team (just to name a few). When the `teamId` parameter is supplied, then the events that are returned will be in relation to the Team that was specified.

## Authentication

**bearerToken**: HTTP bearer

## Query parameters

| Name | Type | Required | Description |
|---|---|---|---|
| `limit` | number | No | Maximum number of items which may be returned. |
| `since` | string | No | Timestamp to only include items created since then. |
| `until` | string | No | Timestamp to only include items created until then. |
| `types` | string | No | Comma-delimited list of event "types" to filter the results by. |
| `userId` | string | No | Deprecated. Use `principalId` instead. If `principalId` and `userId` both exist, `principalId` will be used. |
| `principalId` | string | No | When retrieving events for a Team, the `principalId` parameter may be specified to filter events generated by a specific principal. |
| `projectIds` | string | No | Comma-delimited list of project IDs to filter the results by. |
| `withPayload` | string | No | When set to `true`, the response will include the `payload` field for each event. |
| `teamId` | string | No | The Team identifier to perform the request on behalf of. |
| `slug` | string | No | The Team slug to perform the request on behalf of. |


## Responses

### 200: Successful response.

Content-Type: `application/json`

```json
{
  "type": "object",
  "description": "Successful response.",
  "required": [
    "events"
  ],
  "properties": {
    "events": {
      "type": "array",
      "description": "Array of events generated by the User.",
      "items": {
        "type": "object",
        "description": "Array of events generated by the User.",
        "required": [
          "createdAt",
          "entities",
          "id",
          "principalId",
          "text",
          "userId"
        ],
        "properties": {
          "id": {
            "type": "string",
            "description": "The unique identifier of the Event."
          },
          "text": {
            "type": "string",
            "description": "The human-readable text of the Event."
          },
          "entities": {
            "type": "array",
            "description": "A list of \"entities\" within the event `text`. Useful for enhancing the displayed text with additional styling and links.",
            "items": {
              "type": "object",
              "description": "A list of \"entities\" within the event `text`. Useful for enhancing the displayed text with additional styling and links.",
              "required": [
                "end",
                "start",
                "type"
              ],
              "properties": {
                "type": {
                  "type": "string",
                  "description": "The type of entity.",
                  "enum": [
                    "app",
                    "author",
                    "bitbucket_login",
                    "bold",
                    "deployment_host",
                    "dns_record",
                    "git_link",
                    "github_login",
                    "gitlab_login",
                    "hook_name",
                    "integration",
                    "edge-config",
                    "flag",
                    "flags-segment",
                    "flags-settings",
                    "link",
                    "project_name",
                    "scaling_rules",
                    "env_var_name",
                    "target",
                    "store",
                    "system"
                  ]
                },
                "start": {
                  "type": "number",
                  "description": "The index of where the entity begins within the `text` (inclusive)."
                },
                "end": {
                  "type": "number",
                  "description": "The index of where the entity ends within the `text` (non-inclusive)."
                }
              }
            }
          },
          "type": {
            "type": "string",
            "description": "The type of the event.",
            "enum": [
              "team",
              "avatar",
              "alias",
              "plan",
              "flag",
              "deployment",
              "ai-gateway-api-key-created",
              "ai-gateway-api-key-deleted",
              "ai-gateway-byok-credential-created",
              "ai-gateway-byok-credential-deleted",
              "ai-gateway-byok-credential-updated",
              "access-group-created",
              "access-group-deleted",
              "access-group-project-updated",
              "access-group-updated",
              "access-group-user-added",
              "access-group-user-removed",
              "password-protection-disabled",
              "password-protection-enabled",
              "aliases-assigned",
              "alias-chown",
              "alias-delete",
              "alias-invite-created",
              "alias-invite-joined",
              "alias-invite-revoked",
              "alias-protection-bypass-created",
              "alias-protection-bypass-exception",
              "alias-protection-bypass-regenerated",
              "alias-protection-bypass-revoked",
              "alias-system",
              "alias-user-scoped-access-denied",
              "alias-user-scoped-access-granted",
              "alias-user-scoped-access-requested",
              "alias-user-scoped-access-revoked",
              "oauth-app-connection-created",
              "oauth-app-connection-removed",
              "oauth-app-connection-updated",
              "oauth-app-created",
              "oauth-app-deleted",
              "vercel-app-installation-request-dismissed",
              "vercel-app-installation-requested",
              "vercel-app-installation-updated",
              "vercel-app-installed",
              "oauth-app-secret-deleted",
              "oauth-app-secret-generated",
              "oauth-app-token-created",
              "vercel-app-tokens-revoked",
              "vercel-app-uninstalled",
              "oauth-app-updated",
              "attack-mode-disabled",
              "attack-mode-enabled",
              "auto-expose-system-envs",
              "invoice-refunded",
              "invoice-modified",
              "payment-method-added",
              "payment-method-default-updated",
              "payment-method-removed",
              "subscription-created",
              "subscription-updated",
              "subscription-product-added",
              "subscription-product-removed",
              "bulk-redirects-settings-updated",
              "bulk-redirects-version-promoted",
              "bulk-redirects-version-restored",
              "cert",
              "cert-system-create",
              "cert-autorenew",
              "cert-chown",
              "cert-clone",
              "cert-delete",
              "cert-renew",
              "cert-replace",
              "connect-configuration-created",
              "connect-configuration-deleted",
              "connect-configuration-link-updated",
              "connect-configuration-linked",
              "connect-configuration-unlinked",
              "connect-configuration-updated",
              "connect-github",
              "disconnect-github",
              "connect-github-limited",
              "disconnect-github-limited",
              "connect-github-custom-host",
              "disconnect-github-custom-host",
              "connect-gitlab",
              "connect-gitlab-app",
              "disconnect-gitlab-app",
              "connect-bitbucket",
              "connect-bitbucket-app",
              "disconnect-bitbucket-app",
              "custom-suffix-clear",
              "custom-suffix-disable",
              "preview-deployment-suffix-disabled",
              "custom-suffix-enable",
              "preview-deployment-suffix-enabled",
              "custom-suffix-pending",
              "custom-suffix-ready",
              "deploy-hook-created",
              "deploy-hook-deleted",
              "deploy-hook-deduped",
              "deploy-hook-processed",
              "deployment-check-created",
              "deployment-check-updated",
              "deployment-check-deleted",
              "authorize-git-deployment",
              "deployment-chown",
              "deployment-creation-blocked",
              "deployment-delete",
              "disabled-integration-installation-removed",
              "dns-add",
              "dns-delete",
              "dns-update",
              "domain",
              "domain-buy",
              "domain-cdn",
              "domain-chown",
              "domain-delegated",
              "domain-delete",
              "domain-service-type-updated",
              "domain-custom-ns-change",
              "dns-zonefile-import",
              "domain-zone-change",
              "domain-move-in",
              "domain-move-out",
              "domain-move-out-request-sent",
              "domain-renew-change",
              "domain-transfer-in",
              "domain-transfer-in-canceled",
              "domain-transfer-in-completed",
              "drain-created",
              "drain-deleted",
              "drain-disabled",
              "drain-enabled",
              "drain-updated",
              "edge-cache-dangerously-delete-by-src-images",
              "edge-cache-dangerously-delete-by-tags",
              "edge-cache-invalidate-by-src-images",
              "edge-cache-invalidate-by-tags",
              "edge-cache-purge-all",
              "edge-cache-rollback-purge",
              "edge-config-created",
              "edge-config-deleted",
              "edge-config-items-updated",
              "edge-config-schema-deleted",
              "edge-config-schema-updated",
              "edge-config-transfer-in",
              "edge-config-transfer-out",
              "edge-config-token-created",
              "edge-config-token-deleted",
              "edge-config-updated",
              "email",
              "email-notification-rule-removed",
              "email-notification-rule-updated",
              "env-variable-add",
              "env-variable-delete",
              "env-variable-edit",
              "env-variable-read",
              "env-variable-read:cli:dev",
              "env-variable-read:cli:env:add",
              "env-variable-read:cli:env:ls",
              "env-variable-read:cli:env:pull",
              "env-variable-read:cli:env:rm",
              "env-variable-read:cli:pull",
              "env-variable-read:unknown-source",
              "env-variable-read:v0:env:pull",
              "env-variable-rotated",
              "shared-env-variable-create",
              "shared-env-variable-delete",
              "shared-env-variable-read",
              "shared-env-variable-update",
              "firewall-bypass-created",
              "firewall-bypass-deleted",
              "firewall-config-modified",
              "firewall-config-promoted",
              "firewall-config-removed",
              "firewall-managed-rulegroup-updated",
              "firewall-managed-ruleset-updated",
              "flags-segment",
              "flags-settings",
              "flag-created",
              "flag-updated",
              "flag-deleted",
              "flag-archived",
              "flag-unarchived",
              "flags-explorer-subscription",
              "flags-sdk-key",
              "flags-sdk-key-added",
              "flags-sdk-key-deleted",
              "flags-sdk-key-read",
              "instant-rollback-created",
              "integration-configuration-owner-changed",
              "integration-configuration-scope-change-confirmed",
              "integration-configurations-disabled",
              "integration-installation-billing-plan-updated",
              "integration-installation-completed",
              "integration-installation-permission-updated",
              "integration-installation-removed",
              "integration-scope-changed",
              "log-drain-created",
              "log-drain-deleted",
              "log-drain-disabled",
              "log-drain-enabled",
              "login",
              "manual-deployment-promotion-created",
              "microfrontend-group-added",
              "microfrontend-group-deleted",
              "microfrontend-group-updated",
              "microfrontend-project-added-to-group",
              "microfrontend-project-removed-from-group",
              "microfrontend-project-updated",
              "monitoring-disabled",
              "monitoring-enabled",
              "observability-disabled",
              "observability-enabled",
              "observability-plus-project-disabled",
              "observability-plus-project-enabled",
              "owner-blocked",
              "owner-unblocked",
              "owner-soft-blocked",
              "owner-soft-unblocked",
              "page-integrity-config-updated",
              "page-integrity-header-approved",
              "page-integrity-resource-approved",
              "page-integrity-resource-deleted",
              "page-integrity-resource-rejected",
              "passkey-created",
              "passkey-deleted",
              "passkey-updated",
              "preview-deployment-suffix-update",
              "privatelink-endpoint-created",
              "privatelink-endpoint-deleted",
              "privatelink-endpoint-updated",
              "production-branch-updated",
              "project-directory-listing",
              "project-analytics-disabled",
              "project-speed-insights-disabled",
              "project-analytics-enabled",
              "project-speed-insights-enabled",
              "project-automation-bypass",
              "project-affected-projects-deployments-updated",
              "project-external-rewrite-caching-updated",
              "project-build-command-updated",
              "project-framework-updated",
              "project-install-command-updated",
              "project-node-version-updated",
              "project-output-directory-updated",
              "project-prioritize-production-builds-updated",
              "project-root-directory-updated",
              "project-source-files-outside-root-directory-updated",
              "project-build-machine-updated",
              "project-client-cert-delete",
              "project-client-cert-upload",
              "project-connect-configurations",
              "project-created",
              "project-cron-jobs-toggled",
              "project-delegated-protection-enabled",
              "project-delegated-protection-updated",
              "project-delegated-protection-disabled",
              "project-delete",
              "project-domain-unverified",
              "project-domain-verified",
              "project-elastic-concurrency-updated",
              "project-auto-assign-custom-production-domains-updated",
              "project-preview-environment-branch-tracking-updated",
              "project-custom-environment-updated",
              "project-custom-environment-created",
              "project-custom-environment-deleted",
              "project-functions-beta-updated",
              "project-functions-fluid-disabled",
              "project-functions-fluid-enabled",
              "project-function-max-duration",
              "project-function-cpu-memory",
              "project-function-regions",
              "project-function-failover",
              "project-preview-deployment-suffix",
              "project-name",
              "project-git-repository-connected",
              "project-git-repository-disconnected",
              "project-git-pr-comments-toggled",
              "project-git-commit-comments-toggled",
              "project-git-repository-dispatch-events-toggled",
              "project-git-create-deployments-toggled",
              "project-git-require-verified-commits-toggled",
              "team-git-require-verified-commits-toggled",
              "project-git-commit-status-toggled",
              "project-git-lfs-toggled",
              "project-consolidated-git-commit-status-updated",
              "project-ignored-build-step-updated",
              "project-add-alias",
              "project-add-redirect",
              "project-domain-deleted",
              "project-domain-moved",
              "project-domain-updated",
              "project-member-removed-batch",
              "project-alias-configured-change",
              "project-member-added",
              "project-member-invited",
              "project-member-removed",
              "project-member-updated",
              "project-move-in-success",
              "project-move-out-failed",
              "project-move-out-started",
              "project-move-out-success",
              "project-oidc-token-created",
              "project-options-allowlist",
              "project-password-protection",
              "project-paused",
              "project-program-enrollment-changed",
              "project-rolling-release-enabled",
              "project-rolling-release-disabled",
              "project-rolling-release-configured",
              "project-rolling-release-started",
              "project-rolling-release-completed",
              "project-rolling-release-aborted",
              "project-rolling-release-approved",
              "project-rolling-release-timer",
              "project-rolling-release-paused",
              "project-rolling-release-continued",
              "project-rolling-release-suggested-actions-generated",
              "project-routes-version-promoted",
              "project-routes-version-restored",
              "project-oidc-issuer-mode-updated",
              "project-customer-success-code-visibility-updated",
              "project-git-fork-protection-updated",
              "project-protected-sourcemaps-updated",
              "project-build-logs-and-source-protection-updated",
              "project-deployment-retention-updated",
              "project-skew-protection-threshold-updated",
              "project-skew-protection-max-age-updated",
              "project-skew-protection-allowed-domains-updated",
              "project-sso-protection",
              "project-static-ips-updated",
              "project-trusted-ips",
              "project-trusted-sources",
              "project-unpaused",
              "project-web-analytics-disabled",
              "project-web-analytics-enabled",
              "protected-git-scope-added",
              "protected-git-scope-removed",
              "runtime-cache-purge-all",
              "scale",
              "scale-auto",
              "secondary-email-added",
              "secondary-email-removed",
              "secondary-email-verified",
              "secret-add",
              "secret-delete",
              "secret-rename",
              "security-plus-updated",
              "set-bio",
              "set-name",
              "set-profiles",
              "set-scale",
              "signup",
              "signup-via-bitbucket",
              "signup-via-github",
              "signup-via-gitlab",
              "speed-insights-settings-updated",
              "spend-created",
              "spend-deleted",
              "spend-updated",
              "storage-accept-tos",
              "storage-transfer-request-created",
              "storage-transfer-out-success",
              "storage-transfer-in-success",
              "storage-create",
              "storage-reset-credentials",
              "storage-update",
              "storage-connect-project",
              "storage-disconnect-project",
              "storage-update-project-connection",
              "storage-upgrade-project-connection-to-oidc",
              "storage-delete",
              "storage-accessed-data-browser",
              "storage-view-secret",
              "storage-inactive-store-deleted",
              "storage-resource-repl-command",
              "storage-disconnect-projects",
              "storage-access-token-set",
              "storage-set-locked",
              "ai-code-review",
              "ai-alert-investigation",
              "vercel-agent-team-trial-credits-applied",
              "team-avatar-update",
              "team-default-build-machine-updated",
              "team-delete",
              "strict-deployment-protection-settings",
              "strict-shareable-links",
              "team-domain-verification-created",
              "team-domain-verification-deleted",
              "team-domain-verification-verified",
              "team-emu-updated",
              "vercel-toolbar",
              "team-email-domain-update",
              "team-invite-bulk-delete",
              "team-member-add",
              "team-member-confirm-request",
              "team-member-decline-request",
              "team-member-delete",
              "team-member-entitlement-added",
              "team-member-entitlement-canceled",
              "team-member-entitlement-reactivated",
              "team-member-entitlement-removed",
              "team-member-join",
              "team-member-leave",
              "team-member-request-access",
              "team-member-role-update",
              "team-mfa-enforcement-updated",
              "team-invite-link-created",
              "team-invite-link-deleted",
              "concurrent-builds-update",
              "team-ended-trial",
              "team-paid-invoice",
              "team-invite-code-reset",
              "team-name-update",
              "team-program-enrollment-changed",
              "team-remote-caching-update",
              "enforce-sensitive-environment-variables",
              "show-ip-addresses",
              "team-saml-enforced",
              "team-saml-roles",
              "team-ip-blocking-rules-created",
              "team-ip-blocking-rules-removed",
              "team-tokens-invalidated",
              "audit-log-export-requested",
              "audit-log-export-downloaded",
              "team-slug-update",
              "unlink-login-connection",
              "user-mfa-removed",
              "user-delete",
              "user-mfa-challenge-verified",
              "user-mfa-configuration-updated",
              "user-mfa-recovery-codes-regenerated",
              "user-mfa-totp-verification-started",
              "user-mfa-totp-verified",
              "user-primary-email-updated",
              "user-token-created",
              "username",
              "alert-rule-created",
              "alert-rule-updated",
              "alert-rule-deleted",
              "vulnerability-banner-dismissed",
              "vpc-peering-connection-accepted",
              "vpc-peering-connection-deleted",
              "vpc-peering-connection-rejected",
              "vpc-peering-connection-updated",
              "web-analytics-tier-updated",
              "webhook-created",
              "webhook-deleted",
              "webhook-updated",
              "v0-chat-created",
              "v0-chat-ai-usage",
              "v0-chat-message-sent",
              "workflow-deployment-key-accessed"
            ]
          },
          "categories": {
            "type": "array",
            "description": "The categories that group this event with related event types. An event can belong to multiple categories (e.g. a firewall event is both Firewall and Security). The first entry is the \"primary\" category. Use the `/events/types` endpoint to discover the full list of categories.",
            "items": {
              "type": "string",
              "description": "The categories that group this event with related event types. An event can belong to multiple categories (e.g. a firewall event is both Firewall and Security). The first entry is the \"primary\" category. Use the `/events/types` endpoint to discover the full list of categories.",
              "enum": [
                "account",
                "ai",
                "ai-gateway",
                "billing",
                "deployment",
                "domain",
                "edge",
                "env-variable",
                "feature-flags",
                "firewall",
                "integration",
                "microfrontends",
                "network",
                "observability",
                "project",
                "security",
                "storage",
                "team",
                "v0",
                "vercel-app",
                "workflow",
                "other"
              ]
            }
          },
          "createdAt": {
            "type": "number",
            "description": "Timestamp (in milliseconds) of when the event was generated."
          },
          "user": {
            "type": "object",
            "description": "Metadata for {@link userId}.",
            "required": [
              "avatar",
              "email",
              "uid",
              "username"
            ],
            "properties": {
              "slug": {
                "type": "string"
              },
              "avatar": {
                "type": "string"
              },
              "email": {
                "type": "string"
              },
              "username": {
                "type": "string"
              },
              "uid": {
                "type": "string"
              }
            }
          },
          "principal": {
            "oneOf": [
              {
                "type": "object",
                "description": "Metadata for {@link principalId}.",
                "required": [
                  "avatar",
                  "email",
                  "uid",
                  "username"
                ],
                "properties": {
                  "type": {
                    "type": "string",
                    "enum": [
                      "user"
                    ]
                  },
                  "avatar": {
                    "type": "string"
                  },
                  "email": {
                    "type": "string"
                  },
                  "slug": {
                    "type": "string"
                  },
                  "uid": {
                    "type": "string"
                  },
                  "username": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "Metadata for {@link principalId}.",
                "required": [
                  "clientId",
                  "name",
                  "type"
                ],
                "properties": {
                  "type": {
                    "type": "string",
                    "enum": [
                      "app"
                    ]
                  },
                  "clientId": {
                    "type": "string"
                  },
                  "name": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "Metadata for {@link principalId}.",
                "required": [
                  "type"
                ],
                "properties": {
                  "type": {
                    "type": "string",
                    "enum": [
                      "system"
                    ]
                  }
                }
              }
            ]
          },
          "via": {
            "type": "array",
            "description": "Metadata for {@link viaIds}.",
            "items": {
              "oneOf": [
                {
                  "type": "object",
                  "description": "Metadata for {@link viaIds}.",
                  "required": [
                    "avatar",
                    "email",
                    "uid",
                    "username"
                  ],
                  "properties": {
                    "type": {
                      "type": "string",
                      "enum": [
                        "user"
                      ]
                    },
                    "avatar": {
                      "type": "string"
                    },
                    "email": {
                      "type": "string"
                    },
                    "slug": {
                      "type": "string"
                    },
                    "uid": {
                      "type": "string"
                    },
                    "username": {
                      "type": "string"
                    }
                  }
                },
                {
                  "type": "object",
                  "description": "Metadata for {@link viaIds}.",
                  "required": [
                    "clientId",
                    "name",
                    "type"
                  ],
                  "properties": {
                    "type": {
                      "type": "string",
                      "enum": [
                        "app"
                      ]
                    },
                    "clientId": {
                      "type": "string"
                    },
                    "name": {
                      "type": "string"
                    }
                  }
                },
                {
                  "type": "object",
                  "description": "Metadata for {@link viaIds}.",
                  "required": [
                    "type"
                  ],
                  "properties": {
                    "type": {
                      "type": "string",
                      "enum": [
                        "system"
                      ]
                    }
                  }
                }
              ]
            }
          },
          "userId": {
            "type": "string",
            "description": "When the principal who generated the event is a user, this is their ID; otherwise, it is empty."
          },
          "principalId": {
            "type": "string",
            "description": "The ID of the principal who generated the event. The principal is typically a user, but it could also be an app, an integration, etc. The principal may have delegated its authority to an acting party, and so {@link viaIds} should be checked as well."
          },
          "viaIds": {
            "type": "array",
            "description": "If the principal delegated its authority (for example, a user delegating to an app), then this array contains the ID of the current actor. For example, if `principalId` is \"user123\" and `viaIds` is `[\"app456\"]`, we can say the event was triggered by - \"app456 on behalf of user123\", or - \"user123 via app4556\". Both are equivalent. Arbitrarily long chains of delegation can be represented. For example, if `principalId` is \"user123\" and `viaIds` is `[\"service1\", \"service2\"]`, we can say the event was triggered by \"user123 via service1 via service2\".",
            "items": {
              "type": "string"
            }
          },
          "payload": {
            "oneOf": [
              {
                "type": "object",
                "description": "The payload of the event, if requested."
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "action",
                  "id",
                  "projectId",
                  "slug"
                ],
                "properties": {
                  "action": {
                    "type": "string",
                    "enum": [
                      "deleted",
                      "created",
                      "updated",
                      "archived",
                      "unarchived"
                    ]
                  },
                  "id": {
                    "type": "string"
                  },
                  "slug": {
                    "type": "string"
                  },
                  "projectId": {
                    "type": "string"
                  },
                  "projectName": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "action",
                  "environment"
                ],
                "properties": {
                  "action": {
                    "type": "string",
                    "enum": [
                      "deleted",
                      "added",
                      "rotated"
                    ]
                  },
                  "label": {
                    "type": "string"
                  },
                  "projectName": {
                    "type": "string"
                  },
                  "projectId": {
                    "type": "string"
                  },
                  "environment": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "action",
                  "environment"
                ],
                "properties": {
                  "action": {
                    "type": "string",
                    "enum": [
                      "read"
                    ]
                  },
                  "projectName": {
                    "type": "string"
                  },
                  "projectId": {
                    "type": "string"
                  },
                  "environment": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "apiKey"
                ],
                "properties": {
                  "apiKey": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "credential"
                ],
                "properties": {
                  "credential": {
                    "type": "object",
                    "required": [
                      "id",
                      "name",
                      "providerSlug"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      },
                      "providerSlug": {
                        "type": "string"
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "accessGroup"
                ],
                "properties": {
                  "accessGroup": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "teamRoles": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "teamPermissions": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "entitlements": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "accessGroup",
                  "author"
                ],
                "properties": {
                  "author": {
                    "type": "string"
                  },
                  "accessGroup": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "accessGroup",
                  "project"
                ],
                "properties": {
                  "accessGroup": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "project": {
                    "type": "object",
                    "required": [
                      "id"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "next_role": {
                    "type": "string",
                    "enum": [
                      "ADMIN",
                      "PROJECT_DEVELOPER",
                      "PROJECT_VIEWER",
                      "PROJECT_GUEST",
                      null
                    ],
                    "nullable": true
                  },
                  "previous_role": {
                    "type": "string",
                    "enum": [
                      "ADMIN",
                      "PROJECT_DEVELOPER",
                      "PROJECT_VIEWER",
                      "PROJECT_GUEST"
                    ]
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "accessGroup"
                ],
                "properties": {
                  "accessGroup": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "name": {
                    "type": "string"
                  },
                  "previousName": {
                    "type": "string"
                  },
                  "teamRoles": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "previousTeamRoles": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "teamPermissions": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "previousTeamPermissions": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "entitlementsAdded": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "entitlementsRemoved": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "accessGroup",
                  "user"
                ],
                "properties": {
                  "accessGroup": {
                    "type": "object",
                    "required": [
                      "id"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "user": {
                    "type": "object",
                    "required": [
                      "id"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "username": {
                        "type": "string"
                      }
                    }
                  },
                  "directoryType": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "price": {
                    "type": "number"
                  },
                  "currency": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "alias": {
                    "type": "string"
                  },
                  "deployment": {
                    "type": "object",
                    "nullable": true,
                    "required": [
                      "id",
                      "meta",
                      "name",
                      "url"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      },
                      "url": {
                        "type": "string"
                      },
                      "meta": {
                        "type": "object",
                        "additionalProperties": {
                          "type": "string"
                        }
                      },
                      "readyState": {
                        "type": "string"
                      },
                      "allowListedReadyStateReasonInternal": {
                        "type": "string",
                        "description": "A narrowed subset of the deployment's `readyStateReasonInternal` — only values in the public allowlist are permitted here. Callers should run their raw reason through `toAllowListedReadyStateReasonInternal` from `@api/events` before assigning. This keeps abuse / moderation / admin reasons out of the public activity log.",
                        "enum": [
                          "EARLY_IGNORE_STEP",
                          "IGNORE_STEP",
                          "NAMESPACE_PRUNED",
                          "UNAFFECTED_PROJECT",
                          "UNVERIFIED_COMMIT"
                        ]
                      }
                    }
                  },
                  "ruleCount": {
                    "type": "number"
                  },
                  "deploymentUrl": {
                    "type": "string"
                  },
                  "aliasId": {
                    "type": "string"
                  },
                  "deploymentId": {
                    "type": "string",
                    "nullable": true
                  },
                  "oldDeploymentId": {
                    "type": "string",
                    "nullable": true
                  },
                  "redirect": {
                    "type": "string"
                  },
                  "redirectStatusCode": {
                    "type": "number",
                    "nullable": true
                  },
                  "target": {
                    "type": "string",
                    "nullable": true
                  },
                  "system": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "aliasUpdatedAt": {
                    "type": "number"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "aliasCount",
                  "projectId"
                ],
                "properties": {
                  "projectId": {
                    "type": "string"
                  },
                  "aliasCount": {
                    "type": "number"
                  },
                  "deployment": {
                    "type": "object",
                    "nullable": true,
                    "required": [
                      "id",
                      "meta",
                      "name",
                      "url"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      },
                      "url": {
                        "type": "string"
                      },
                      "meta": {
                        "type": "object",
                        "additionalProperties": {
                          "type": "string"
                        }
                      },
                      "readyState": {
                        "type": "string"
                      },
                      "allowListedReadyStateReasonInternal": {
                        "type": "string",
                        "description": "A narrowed subset of the deployment's `readyStateReasonInternal` — only values in the public allowlist are permitted here. Callers should run their raw reason through `toAllowListedReadyStateReasonInternal` from `@api/events` before assigning. This keeps abuse / moderation / admin reasons out of the public activity log.",
                        "enum": [
                          "EARLY_IGNORE_STEP",
                          "IGNORE_STEP",
                          "NAMESPACE_PRUNED",
                          "UNAFFECTED_PROJECT",
                          "UNVERIFIED_COMMIT"
                        ]
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "alias"
                ],
                "properties": {
                  "name": {
                    "type": "string"
                  },
                  "alias": {
                    "type": "string"
                  },
                  "oldTeam": {
                    "type": "object",
                    "required": [
                      "name"
                    ],
                    "properties": {
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "newTeam": {
                    "type": "object",
                    "required": [
                      "name"
                    ],
                    "properties": {
                      "name": {
                        "type": "string"
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "alias",
                  "aliasId",
                  "deploymentId"
                ],
                "properties": {
                  "name": {
                    "type": "string"
                  },
                  "alias": {
                    "type": "string"
                  },
                  "aliasId": {
                    "type": "string"
                  },
                  "deploymentId": {
                    "type": "string",
                    "nullable": true
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "alias": {
                    "type": "string"
                  },
                  "email": {
                    "type": "string"
                  },
                  "username": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "alias": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "alias": {
                    "type": "string"
                  },
                  "email": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "aliasId": {
                    "type": "string"
                  },
                  "alias": {
                    "type": "string"
                  },
                  "projectName": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "action",
                  "alias",
                  "projectName"
                ],
                "properties": {
                  "projectName": {
                    "type": "string"
                  },
                  "alias": {
                    "type": "string"
                  },
                  "action": {
                    "type": "string",
                    "enum": [
                      "created",
                      "removed"
                    ]
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "alias",
                  "deploymentUrl"
                ],
                "properties": {
                  "alias": {
                    "type": "string"
                  },
                  "deploymentUrl": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "alias": {
                    "type": "string"
                  },
                  "userId": {
                    "type": "string"
                  },
                  "username": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "alias": {
                    "type": "string"
                  },
                  "aliasId": {
                    "type": "string"
                  },
                  "userId": {
                    "type": "string"
                  },
                  "username": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "appName",
                  "scopes"
                ],
                "properties": {
                  "appName": {
                    "type": "string"
                  },
                  "appId": {
                    "type": "string"
                  },
                  "scopes": {
                    "type": "array",
                    "items": {
                      "type": "string",
                      "enum": [
                        "openid",
                        "email",
                        "profile",
                        "offline_access"
                      ]
                    }
                  },
                  "permissions": {
                    "type": "array",
                    "items": {
                      "type": "string",
                      "enum": [
                        "*",
                        "read:user",
                        "read:domain",
                        "read-write:domain",
                        "read:team",
                        "read:billing",
                        "read-write:billing",
                        "read-write:ai-gateway-api-key",
                        "use:ai-gateway",
                        "read-write:project-env-vars",
                        "read-write:drains",
                        "read-write:edge-config",
                        "read:monitoring",
                        "read:access-group",
                        "read:integration-configuration",
                        "read-write:integration-configuration",
                        "read-write:integration-resource",
                        "read-write:blob",
                        "read:event",
                        "read-write:remote-cache",
                        "read:project",
                        "read-write:project",
                        "read:deployment",
                        "read-write:deployment",
                        "read-write:edge-cache",
                        "read-write:project-protection-bypass",
                        "read:project-env-vars-non-production",
                        "read-write:project-env-vars-non-production",
                        "read:project-env-vars-production",
                        "read-write:project-env-vars-production",
                        "read-write:project-flags-non-production",
                        "read-write:project-flags-production",
                        "read-write:domain-registrar",
                        "read:sandbox",
                        "read-write:sandbox"
                      ]
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "appName"
                ],
                "properties": {
                  "appName": {
                    "type": "string"
                  },
                  "appId": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "appName",
                  "nextScopes"
                ],
                "properties": {
                  "appName": {
                    "type": "string"
                  },
                  "appId": {
                    "type": "string"
                  },
                  "nextScopes": {
                    "type": "array",
                    "items": {
                      "type": "string",
                      "enum": [
                        "openid",
                        "email",
                        "profile",
                        "offline_access"
                      ]
                    }
                  },
                  "nextPermissions": {
                    "type": "array",
                    "items": {
                      "type": "string",
                      "enum": [
                        "*",
                        "read:user",
                        "read:domain",
                        "read-write:domain",
                        "read:team",
                        "read:billing",
                        "read-write:billing",
                        "read-write:ai-gateway-api-key",
                        "use:ai-gateway",
                        "read-write:project-env-vars",
                        "read-write:drains",
                        "read-write:edge-config",
                        "read:monitoring",
                        "read:access-group",
                        "read:integration-configuration",
                        "read-write:integration-configuration",
                        "read-write:integration-resource",
                        "read-write:blob",
                        "read:event",
                        "read-write:remote-cache",
                        "read:project",
                        "read-write:project",
                        "read:deployment",
                        "read-write:deployment",
                        "read-write:edge-cache",
                        "read-write:project-protection-bypass",
                        "read:project-env-vars-non-production",
                        "read-write:project-env-vars-non-production",
                        "read:project-env-vars-production",
                        "read-write:project-env-vars-production",
                        "read-write:project-flags-non-production",
                        "read-write:project-flags-production",
                        "read-write:domain-registrar",
                        "read:sandbox",
                        "read-write:sandbox"
                      ]
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "appName"
                ],
                "properties": {
                  "appName": {
                    "type": "string"
                  },
                  "appId": {
                    "type": "string"
                  },
                  "installationId": {
                    "type": "string"
                  },
                  "before": {
                    "type": "object",
                    "properties": {
                      "resources": {
                        "type": "object",
                        "required": [
                          "projectIds"
                        ],
                        "properties": {
                          "projectIds": {
                            "type": "object",
                            "required": [
                              "items",
                              "required",
                              "type"
                            ],
                            "properties": {
                              "type": {
                                "type": "string",
                                "enum": [
                                  "list"
                                ]
                              },
                              "required": {
                                "type": "boolean",
                                "enum": [
                                  true
                                ]
                              },
                              "items": {
                                "type": "object",
                                "required": [
                                  "type"
                                ],
                                "properties": {
                                  "type": {
                                    "type": "string",
                                    "enum": [
                                      "string"
                                    ]
                                  }
                                }
                              }
                            }
                          }
                        }
                      },
                      "permissions": {
                        "type": "array",
                        "items": {
                          "type": "string",
                          "enum": [
                            "read:domain",
                            "read-write:domain",
                            "read:team",
                            "read:billing",
                            "read-write:billing",
                            "read-write:ai-gateway-api-key",
                            "use:ai-gateway",
                            "read-write:project-env-vars",
                            "read-write:drains",
                            "read-write:edge-config",
                            "read:monitoring",
                            "read:access-group",
                            "read:integration-configuration",
                            "read-write:integration-configuration",
                            "read-write:integration-resource",
                            "read-write:blob",
                            "read:event",
                            "read-write:remote-cache",
                            "read:project",
                            "read-write:project",
                            "read:deployment",
                            "read-write:deployment",
                            "read-write:edge-cache",
                            "read-write:project-protection-bypass",
                            "read:project-env-vars-non-production",
                            "read-write:project-env-vars-non-production",
                            "read:project-env-vars-production",
                            "read-write:project-env-vars-production",
                            "read-write:project-flags-non-production",
                            "read-write:project-flags-production",
                            "read-write:domain-registrar",
                            "read:sandbox",
                            "read-write:sandbox"
                          ]
                        }
                      }
                    }
                  },
                  "after": {
                    "type": "object",
                    "properties": {
                      "resources": {
                        "type": "object",
                        "required": [
                          "projectIds"
                        ],
                        "properties": {
                          "projectIds": {
                            "type": "object",
                            "required": [
                              "items",
                              "required",
                              "type"
                            ],
                            "properties": {
                              "type": {
                                "type": "string",
                                "enum": [
                                  "list"
                                ]
                              },
                              "required": {
                                "type": "boolean",
                                "enum": [
                                  true
                                ]
                              },
                              "items": {
                                "type": "object",
                                "required": [
                                  "type"
                                ],
                                "properties": {
                                  "type": {
                                    "type": "string",
                                    "enum": [
                                      "string"
                                    ]
                                  }
                                }
                              }
                            }
                          }
                        }
                      },
                      "permissions": {
                        "type": "array",
                        "items": {
                          "type": "string",
                          "enum": [
                            "read:domain",
                            "read-write:domain",
                            "read:team",
                            "read:billing",
                            "read-write:billing",
                            "read-write:ai-gateway-api-key",
                            "use:ai-gateway",
                            "read-write:project-env-vars",
                            "read-write:drains",
                            "read-write:edge-config",
                            "read:monitoring",
                            "read:access-group",
                            "read:integration-configuration",
                            "read-write:integration-configuration",
                            "read-write:integration-resource",
                            "read-write:blob",
                            "read:event",
                            "read-write:remote-cache",
                            "read:project",
                            "read-write:project",
                            "read:deployment",
                            "read-write:deployment",
                            "read-write:edge-cache",
                            "read-write:project-protection-bypass",
                            "read:project-env-vars-non-production",
                            "read-write:project-env-vars-non-production",
                            "read:project-env-vars-production",
                            "read-write:project-env-vars-production",
                            "read-write:project-flags-non-production",
                            "read-write:project-flags-production",
                            "read-write:domain-registrar",
                            "read:sandbox",
                            "read-write:sandbox"
                          ]
                        }
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "appName"
                ],
                "properties": {
                  "appName": {
                    "type": "string"
                  },
                  "appId": {
                    "type": "string"
                  },
                  "resources": {
                    "type": "object",
                    "required": [
                      "projectIds"
                    ],
                    "properties": {
                      "projectIds": {
                        "type": "object",
                        "required": [
                          "items",
                          "required",
                          "type"
                        ],
                        "properties": {
                          "type": {
                            "type": "string",
                            "enum": [
                              "list"
                            ]
                          },
                          "required": {
                            "type": "boolean",
                            "enum": [
                              true
                            ]
                          },
                          "items": {
                            "type": "object",
                            "required": [
                              "type"
                            ],
                            "properties": {
                              "type": {
                                "type": "string",
                                "enum": [
                                  "string"
                                ]
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  "permissions": {
                    "type": "array",
                    "items": {
                      "type": "string",
                      "enum": [
                        "read:domain",
                        "read-write:domain",
                        "read:team",
                        "read:billing",
                        "read-write:billing",
                        "read-write:ai-gateway-api-key",
                        "use:ai-gateway",
                        "read-write:project-env-vars",
                        "read-write:drains",
                        "read-write:edge-config",
                        "read:monitoring",
                        "read:access-group",
                        "read:integration-configuration",
                        "read-write:integration-configuration",
                        "read-write:integration-resource",
                        "read-write:blob",
                        "read:event",
                        "read-write:remote-cache",
                        "read:project",
                        "read-write:project",
                        "read:deployment",
                        "read-write:deployment",
                        "read-write:edge-cache",
                        "read-write:project-protection-bypass",
                        "read:project-env-vars-non-production",
                        "read-write:project-env-vars-non-production",
                        "read:project-env-vars-production",
                        "read-write:project-env-vars-production",
                        "read-write:project-flags-non-production",
                        "read-write:project-flags-production",
                        "read-write:domain-registrar",
                        "read:sandbox",
                        "read-write:sandbox"
                      ]
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "appName"
                ],
                "properties": {
                  "appName": {
                    "type": "string"
                  },
                  "appId": {
                    "type": "string"
                  },
                  "secretLastFourChars": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "appName"
                ],
                "properties": {
                  "appName": {
                    "type": "string",
                    "description": "The App's name at the moment this even was published (it may have changed since then)."
                  },
                  "appId": {
                    "type": "string",
                    "description": "The App's ID. Note that not all historical events have this field."
                  },
                  "app": {
                    "type": "object",
                    "description": "Note that not all historical events have this field.",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string",
                        "description": "The App's ID."
                      },
                      "name": {
                        "type": "string",
                        "description": "The App's name at the moment this even was published (it may have changed since then)."
                      }
                    }
                  },
                  "issuedBefore": {
                    "type": "number",
                    "description": "UNIX timestamp in seconds. Tokens issued before this timestamp will be revoked. Note that not all historical events have this field."
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "attackModeEnabled",
                  "projectId"
                ],
                "properties": {
                  "projectId": {
                    "type": "string"
                  },
                  "prevAttackModeEnabled": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "prevAttackModeActiveUntil": {
                    "type": "number",
                    "nullable": true
                  },
                  "attackModeEnabled": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "attackModeActiveUntil": {
                    "type": "number",
                    "nullable": true
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "autoExposeSystemEnvs",
                  "projectName"
                ],
                "properties": {
                  "projectName": {
                    "type": "string"
                  },
                  "autoExposeSystemEnvs": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "avatar": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "amount",
                  "invoiceId",
                  "lineItemCount",
                  "refundReason"
                ],
                "properties": {
                  "invoiceId": {
                    "type": "string"
                  },
                  "amount": {
                    "type": "number"
                  },
                  "refundReason": {
                    "type": "string"
                  },
                  "lineItemCount": {
                    "type": "number"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "amount",
                  "invoiceId",
                  "newInvoiceId",
                  "settlementMethod"
                ],
                "properties": {
                  "invoiceId": {
                    "type": "string"
                  },
                  "newInvoiceId": {
                    "type": "string"
                  },
                  "settlementMethod": {
                    "type": "string",
                    "enum": [
                      "refunded-paid",
                      "credited-paid"
                    ]
                  },
                  "amount": {
                    "type": "number"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "paymentMethodId"
                ],
                "properties": {
                  "paymentMethodId": {
                    "type": "string"
                  },
                  "brand": {
                    "type": "string"
                  },
                  "last4": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "planSlug"
                ],
                "properties": {
                  "subscriptionId": {
                    "type": "string"
                  },
                  "planSlug": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "action",
                  "data"
                ],
                "properties": {
                  "subscriptionId": {
                    "type": "string"
                  },
                  "action": {
                    "type": "string",
                    "enum": [
                      "cancel_plan"
                    ]
                  },
                  "data": {
                    "type": "object",
                    "required": [
                      "planSlug"
                    ],
                    "properties": {
                      "planSlug": {
                        "type": "string",
                        "enum": [
                          "v0_teams",
                          "v0_business"
                        ]
                      },
                      "reason": {
                        "type": "string",
                        "enum": [
                          "non-payment"
                        ]
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "action",
                  "data"
                ],
                "properties": {
                  "subscriptionId": {
                    "type": "string"
                  },
                  "action": {
                    "type": "string",
                    "enum": [
                      "resume_plan"
                    ]
                  },
                  "data": {
                    "type": "object",
                    "required": [
                      "planSlug"
                    ],
                    "properties": {
                      "planSlug": {
                        "type": "string",
                        "enum": [
                          "v0_teams",
                          "v0_business"
                        ]
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "action",
                  "data"
                ],
                "properties": {
                  "subscriptionId": {
                    "type": "string"
                  },
                  "action": {
                    "type": "string",
                    "enum": [
                      "mutate"
                    ]
                  },
                  "data": {
                    "type": "object",
                    "additionalProperties": true
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "productAliases"
                ],
                "properties": {
                  "subscriptionId": {
                    "type": "string"
                  },
                  "productAliases": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "bulkRedirectsLimit",
                  "prevBulkRedirectsLimit",
                  "project"
                ],
                "properties": {
                  "project": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "bulkRedirectsLimit": {
                    "type": "number"
                  },
                  "prevBulkRedirectsLimit": {
                    "type": "number"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "project",
                  "versionId"
                ],
                "properties": {
                  "project": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "versionId": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "custom"
                ],
                "properties": {
                  "cn": {
                    "type": "string"
                  },
                  "cns": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "custom": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "id": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "cns",
                  "custom",
                  "id"
                ],
                "properties": {
                  "id": {
                    "type": "string"
                  },
                  "cns": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "custom": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "cn": {
                    "type": "string"
                  },
                  "cns": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "id": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "id"
                ],
                "properties": {
                  "id": {
                    "type": "string"
                  },
                  "oldTeam": {
                    "type": "object",
                    "required": [
                      "name"
                    ],
                    "properties": {
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "newTeam": {
                    "type": "object",
                    "required": [
                      "name"
                    ],
                    "properties": {
                      "name": {
                        "type": "string"
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "dst",
                  "src"
                ],
                "properties": {
                  "src": {
                    "type": "string"
                  },
                  "dst": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "id"
                ],
                "properties": {
                  "id": {
                    "type": "string"
                  },
                  "cn": {
                    "type": "string"
                  },
                  "cns": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "properties": {
                  "cn": {
                    "type": "string"
                  },
                  "cns": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "configuration"
                ],
                "properties": {
                  "configuration": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "configuration",
                  "project",
                  "team"
                ],
                "properties": {
                  "team": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "configuration": {
                    "type": "object",
                    "required": [
                      "id"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "project": {
                    "type": "object",
                    "required": [
                      "id"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "buildsEnabled": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "configuration",
                  "project",
                  "team"
                ],
                "properties": {
                  "team": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "configuration": {
                    "type": "object",
                    "required": [
                      "id"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "project": {
                    "type": "object",
                    "required": [
                      "id"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "buildsEnabled": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  },
                  "passive": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "configuration",
                  "project",
                  "team"
                ],
                "properties": {
                  "team": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "configuration": {
                    "type": "object",
                    "required": [
                      "id"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "project": {
                    "type": "object",
                    "required": [
                      "id"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "configuration",
                  "newName",
                  "team"
                ],
                "properties": {
                  "team": {
                    "type": "object",
                    "required": [
                      "id",
                      "name"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "configuration": {
                    "type": "object",
                    "required": [
                      "id"
                    ],
                    "properties": {
                      "id": {
                        "type": "string"
                      },
                      "name": {
                        "type": "string"
                      }
                    }
                  },
                  "newName": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "githubLogin"
                ],
                "properties": {
                  "githubLogin": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "githubLogin",
                  "host"
                ],
                "properties": {
                  "githubLogin": {
                    "type": "string"
                  },
                  "host": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "gitlabEmail",
                  "gitlabLogin"
                ],
                "properties": {
                  "gitlabLogin": {
                    "type": "string"
                  },
                  "gitlabEmail": {
                    "type": "string"
                  },
                  "gitlabName": {
                    "type": "string"
                  },
                  "zeitAccount": {
                    "type": "string"
                  },
                  "zeitAccountType": {
                    "type": "string"
                  }
                }
              },
              {
                "type": "object",
                "description": "The payload of the event, if requested.",
                "required": [
                  "gitlabLogin",
                  "gitlabUserId"
                ],
                "properties": {
                  "gitlabLogin": {
                    "type": "string"
                  },
[...]
